<?php
require_once '/usr/local/esia/public_html/plugin/report/report.conf.php';
/*DESCRIPTION: inclus les variables habituelles pour la gestion d'un block et vérifie les droits d'accès
 *APRES l'inclusion du common_block les variables suivantes sont créées:
 *PHP:
 *      $dbconnection objet PDO de connexion à la DB
 *      $webplugin_path chemin d'accès au web plugin de repport (default: /usr/local/esia/public_html/plugin/report/
 *      $lang tableau associatif avec les variables de langue
 *      $action l'action passé dans l'url ou 'view'
 *      $gendate tableau associatif reprenant les paramètres global avec les clés suivantes:
 *               ['start']  timestamps de début
 *               ['end']    timestamps de fin
 *               ['interval'] interval en nombre de jour au format php. voir %a par rapport à la date de début  https://www.php.net/manual/fr/dateinterval.format.php
 *      $block les données du block en DB
 *      $parameters un tableau associatif reprenant les paramètres du block
 * SMARTY
 *      $block les informations du block
 *      $parameters les parametres du block (JSON)
 *      $action l'action passé dans l'url ou 'view'
 */
require_once REPORT_COMMON_BLOCK;
//UPDATE interface web
if($action=="generate")
{
    if( $interval == 1 ) 
    {//One day only
        $date = new DateTime();
        $date->setTime(0,0,0);
        $end_date_ts = $date->getTimestamp();
        $end_date_ts--;
    }
    $nodes = array();
    if($parameters['element_type']=='group_node')
    {
    	$nodes = Model_esia::getAllNodeofGroup($dbconnection, null, $parameters['element_dbid']);
    }
    else 
    {
    	foreach ($parameters['element_dbid'] as $nodeid)
        {
            try
            {
                $infonode=Model_esia::InstanceNode($dbconnection,$nodeid);
                $nodes[]=$infonode;      
            }
            catch(Exception $e)
            {
                
            }
        }	
    }
    $list = array();
    $globalavaibatily=0;
    foreach($nodes as $node)
    {
        $services = Model_esia::getServices($dbconnection, $node->getId());
        $high_priority=100;
        $serviceid=0;
        foreach($services as $service)
        {
            if($service['priority'] < $high_priority)
            {
                $serviceid = $service['id'];
                $high_priority = $service['priority'];
            }
        }
        $avai = array();
        $avai=Model_esia::getTimeErrorAvailability($dbconnection,$node->getId(),$serviceid,$end,$interval);
        $avai = eliminateAvaibilityError($avai,$parameters['calcunknown'],$parameters['calcwarning'],$parameters['calccritical']);
        if($avai['ok']['percent'] <0)
        {
            $avai['ok']['percent']=00;
        }
        $descr = htmlentities($node->getDescription() , ENT_QUOTES);
        $list[$node->getName()]=array('nodeid'=>$node->getId(),
                'name'=>$node->getName(),
                'group'=> $node->getGroup(), 
            	'description'=>$descr,
                'ip'=>$node->getIPAddress(),
                'serviceid'=>$serviceid,
                'available'=>$avai['ok']['percent']);
        $globalavaibatily=$globalavaibatily + $avai['ok']['percent'];
    }
    if($parameters['mergedata']=='on')
    {
        $size = count($list);
        $globalavaibatily= round($globalavaibatily/$size,2);
        $list=array();
        $list['global']=array('nodeid'=>'',
                'name'=>'global',
                'group'=>'', 
            	'description'=>$descr,
                'ip'=>'',
                'serviceid'=>'',
                'available'=>$globalavaibatily);
    }
    else
    {
        ksort($list);
    }
    if(empty($parameters['form']))
    {
    	$parameters['form']='tab2';
    }
    $smarty->assign('parameters',$parameters);
    $smarty->assign('data',$list);
    //génération en graphique chart
    if($parameters['form']=='graphCol')
    {
        $c3data=array("data1");
        $c3headder=array();
        $i=0;
        foreach($list as $line)
        {
            $c3data[]=$line['available'];
            $c3headder[]=$line['name'];
            $i++;
        }
        $smarty->assign('c3data',$c3data);
        $smarty->assign('c3headder',$c3headder);
		$height = 320;
		if($i > 15)
		{
			$i = $i - 15;
			//on augmente la taille de 15px pour chaque noeud au dessus de 15
			$height = $height + ($i * 15);
		}
		$smarty->assign('height',$height);
		
       
    }
}
elseif($action=="node")
{
	$parameters = $block['parameters'];
    $nodes = Model_esia::getNodeList($dbconnection,$user->getId(),null,Model_esia::NODE_INSTANCE);
    $list=array();
    
    foreach($nodes as $node)
    {
        $arr = array('id'=>$node->getId(),'parent_name'=>$node->getGroup().'>'.$node->getName());
        if($params['element_type']=='node')
        {
        	if(in_array($node->getId(),$parameters['element_dbid']))
            {
                $arr['selected']=1;
            }
        }
        $list[]= $arr;
    }
    echo json_encode($list);
}
elseif($action=="group_node")
{
	$parameters = $block['parameters'];
    $arr = Model_esia::getGroupDeviceIn($dbconnection);
    $list =array();
    foreach($arr as $top)
    {
        $tmp = convert_tree_to_select($top,0);
        $list = array_merge($list, $tmp);
    }
    if($parameters['element_type']=='group_node')
    {
        foreach($list as &$elem)
        {
        	if(in_array($elem['id'], $parameters['element_dbid']))
            {
                $elem['selected']=1;
            }
        }
    }
    echo json_encode($list);
    
}
elseif($action=="update")
{
    $smarty->assign('blockid',$query['include_id']);
    $smarty->assign('canevas_id',$query['include_canevas_id']);
    $parameters = $block['parameters'];
    if(isset($_POST['blockid'])&&!empty($_POST['blockid']))
    {
    	try
    	{
	    	$block = getPostDefaultParams($block,$_POST);
	    	$parameters = $block['parameters'];
	
	        //
	        // Forme
	    	$parameters['form']=$_POST['form'];
	        // Seuil de Warning et Critical
	    	$parameters['criticalThreshold']=$_POST['criticalThreshold'];
	    	$parameters['warningThreshold']=$_POST['warningThreshold'];
	        
	        // Calcul de la dispo
	        if( empty($_POST['calcunknown']) )	$_POST['calcunknown'] = 'none';
	        if( empty($_POST['calcwarning']) )	$_POST['calcwarning'] = 'none';
	        if( empty($_POST['calccritical']) )	$_POST['calccritical'] = 'none';
	        if( empty($_POST['mergedata']) )	$_POST['mergedata'] = 'none';
	        $parameters['mergedata'] = $_POST['mergedata'];
	        $parameters['calcunknown']=$_POST['calcunknown'];
	        $parameters['calcwarning']=$_POST['calcwarning'];
	        $parameters['calccritical']=$_POST['calccritical'];
	        
	        //Paramètre du tableau
	        if( empty($_POST['tab_col_group']) )	$_POST['tab_col_group'] = 'none';
	        if( empty($_POST['tab_col_ip']) )	$_POST['tab_col_ip'] = 'none';
	        if( empty($_POST['tab_col_descr']) )	$_POST['tab_col_descr'] = 'none';
	        $parameters['table']['columnshow']['group']=$_POST['tab_col_group'];
	        $parameters['table']['columnshow']['ip']=$_POST['tab_col_ip'];
	        $parameters['table']['columnshow']['description']=$_POST['tab_col_descr'];
	        
	        //Type d'affichage
	        $parameters['element_type']=$_POST['select_type_link'];
	        $parameters['element_dbid']=$_POST['elementselect'];
	       
	        $paramSave = json_encode($parameters);
	        
	        Model_Report::UpdtReportIncludeBlock($dbconnection,$block['id'],$block['include_block_id'],$block['include_canevas_id'],$block['include_position'],$paramSave);        
	        if($parameters['calcunknown']='none' && $parameters['calcwarning']== 'none' && $parameters['calccritical']=='none')
	        {
	            $smarty->assign('l_error',$lang['REPORT_AVA_UNCHECKED_ALLBOXES']);
	        }
	        else
	        {
	            $smarty->assign('l_success',$lang['UPDATE_REPORT_SUCCESS']);
	        }
    	}
    	catch (EsiaDbException $e)
    	{
    		$smarty->assign('l_error',$e->getMessage());
    	}
    	catch (Exception $e)
    	{
    		$smarty->assign('l_error',$e->getMessage());
    	}
       	
    }
    //recupération des styles
    $title = $parameters['title']['style'];
    $description = $parameters['description']['style'];
    if(array_key_exists('color',$title))
    {
    	$title = 'text-align:'.$parameters['title']['style']['text-align'].'; font-size:'.$parameters['title']['style']['font-size'];
    	$title.= 'color:'.$parameters['title']['style']['color'].';';
    	$description = 'text-align:'.$parameters['description']['style']['text-align'].'; font-size:'.$parameters['description']['style']['font-size'];
    	$description.= 'color:'.$parameters['description']['style']['color'].';';
    }
    $title = getBlockStyle($title,14,'left','#575759');
    $description = getBlockStyle($description,12,'left','#575759');
    $smarty->assign('titlestyle',$title);
    $smarty->assign('descriptionstyle',$description);
    
    $smarty->assign('params',$parameters);
    $smarty->assign('action','update');
}
$smarty->display($webplugin_path.'/blocks/templates/connectivity.html');

function eliminateAvaibilityError($percent, $inconnu='on',$warning='on',$critical='on')
{
    if(!isset($percent['ok']['nbrsec']))	$percent['ok']['nbrsec']=0;
    if(!isset($percent['ok']['percent']))	$percent['ok']['percent']=0;
    
    if($inconnu !='on' && isset($percent['unknown']))
    {
        $percent['ok']['nbrsec']= $percent['ok']['nbrsec'] + $percent['unknown']['nbrsec'];
        $percent['ok']['percent']= $percent['ok']['percent'] + $percent['unknown']['percent'];
        $percent['unknown']=array('nbrsec'=>0,'percent'=>0);
    }
    if($warning !='on' && isset($percent['warning']))
    {
        $percent['ok']['nbrsec']= $percent['ok']['nbrsec'] + $percent['warning']['nbrsec'];
        $percent['ok']['percent']= $percent['ok']['percent'] + $percent['warning']['percent'];
        $percent['warning']=array('nbrsec'=>0,'percent'=>0);
    }
    if($critical !='on' && isset($percent['critical']))
    {
        $percent['ok']['nbrsec']= $percent['ok']['nbrsec'] + $percent['critical']['nbrsec'];
        $percent['ok']['percent']= $percent['ok']['percent'] + $percent['critical']['percent'];
        $percent['critical']=array('nbrsec'=>0,'percent'=>0);
    }
    if($percent['ok']['percent'] > 100)
    {
        $percent['ok']['percent']=100;
    }
    return $percent;
}
?>
