<?php

/**
 * @name report_generate
 * @description generation du rapport
 *		Genere le rapport (le code Html et le pdf)
 * @author Victor Marin <v.marin@esia-sa.com>
 * @date Mars 2017
 */

/*if(isset($_SERVER['DOCUMENT_ROOT']) && !empty($_SERVER['DOCUMENT_ROOT']))
{
	$_SERVER['DOCUMENT_ROOT']='/usr/local/esia/public_html/';
}*/
$_SERVER['DOCUMENT_ROOT']='/usr/local/esia/public_html/';

$path = rtrim ($_SERVER['DOCUMENT_ROOT'],'/');
include_once $path.'/esia.conf.php';
include_once MVCMODEL;

$SHORT_OPTS="a:i:n:v:d:f:l:";
$LONG_OPTS=array("action:","idCanevas:","nomRapport:","visualisation:","datemandeb:","datemanfin:","language:");

$options = getopt($SHORT_OPTS, $LONG_OPTS);

$Action	= getParam($options,"action","a");
$Canevas_Id	= getParam($options,"idCanevas","i");
$NomRapport = getParam($options,"nomRapport","n");
$Viewer = getParam($options,"visualisation","v");
$datemandeb = getParam($options,"datemandeb","d");
$datemanfin = getParam($options,"datemanfin","f");
$language = getParam($options,"language","l");

try
{
	$dbconnection = new PDO('pgsql:host='.DB_HOST.';port='.DB_PORT.';dbname='.DB_NAME, DB_USERNAME, DB_PWD);
	$dbconnection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_WARNING);
}
catch(Exception $e)
{
	echo 'PDO SQL ERROR: '.$e->getMessage().'<br />';
	echo 'N° : '.$e->getCode();
}

$arr = Model_esia::getWebPlugin($dbconnection,false,'WEBP_REPORT');
$plugin_path = $path.'/'.$arr[0]['apache_path'];
include_once $plugin_path.'/Model_Report.php';
include_once $plugin_path."/".$arr[0]['dir_lang']."/".$language.".php";

$path_block = "/plugin/report/blocks/";
$path_data = "/data/report/pictures/";
$path_header_footer = "/data/report/";

$Canevas = Model_Report::getReportCanevas($dbconnection,$Canevas_Id);
$Canevas = $Canevas[0];
if(!empty($Canevas)&& $Canevas!=null)
{
	$NameCanevas=str_replace(' ','_',$Canevas['canevas_name']);
	$End = $Canevas['canevas_date_nextgeneration'];
	$Inter = $Canevas['canevas_interval'];
	$param_canevas  = json_decode($Canevas['canevas_parameter'],true);
	$NomClient = $param_canevas['NameClient'];
	$DescriptionHeader = $param_canevas['DescriptionHeader'];
	$NomPersonneGenerateReport = $param_canevas['NomPersonneGenerateReport'];
	if(empty($NomRapport))
	{
		$NomRapport= $param_canevas['title']['text'];
	}
	
	try
	{
		if(isset($datemandeb))
		{			
			$Start = new DateTime($datemandeb);
			$End = new DateTime($datemanfin);
			$Start=date_format($Start,'Y-m-d');
			$End=date_format($End,'Y-m-d');
		}
		else
		{
			$dateEnd = new DateTime($End);
			$date = new DateTime($End);			
			if($dateEnd>date("Y-m-d"))
			{
				$End=date("Y-m-d");
				$date = new DateTime($End);
			}
		
			if($Inter=="1 mon")
			{
				date_sub($date, date_interval_create_from_date_string('1 month'));
			}
			else
			{
				date_sub($date, date_interval_create_from_date_string($Inter));
			}
			$Start = date_format($date, 'Y-m-d');
		}

		$query = Model_Report::getReportAll_Include_Block($dbconnection,$Canevas_Id);
		if(!empty($query)&& $query!=null)
		{	
			$output="";
			foreach($query as $val)
			{
				$IdInclude = $val['include_id'];
				$Id = $val['include_block_id'];
				$Controller = $val['block_controller'];
			
				$output.= shell_exec("php ".$path.$path_block.$Controller." -a ".$Action." -i ".$IdInclude." -s '".$Start."' -e '".$End."' -l '".$language."'");
			}
			if(!empty($output)&& $output!=null)
			{			
				$date = date("d-m-Y-H-i-s");						
				$NomRapport=str_replace(' ','_',$NomRapport);
				
				$tmpNameCanevas = remove_accents($NameCanevas);
				$tmpNomRapport = remove_accents($NomRapport);
				
				$filenamePdf = "/data/report/canevas/".$tmpNameCanevas ."/".$tmpNomRapport ."_".$date.".pdf";
				$filenameHtml = $path."/data/report/canevas/".$tmpNameCanevas ."/".$tmpNomRapport ."_".$date.".html";				
														
				// Personalisation du Footer
				$today = date("d/m/Y h:m:s");
				$DateFooter = str_replace("D",$today, $lang['REPORT_FOOTER_REPORT']);
				$footer = str_replace("FOOTER",$DateFooter.$NomPersonneGenerateReport,file_get_contents("".$path.$path_header_footer."footer.html"));
					
				// Personalisation du Header
				$Start = date_format(new DateTime($Start), 'd/m/Y');
				$End = date_format(new DateTime($End), 'd/m/Y');
				$DateHeader = str_replace("DateDebut",$Start,$lang['REPORT_HEADER_DATE']);		
				$DateHeader = str_replace("DateFin",$End,$DateHeader);				
				$Titre = str_replace('_',' ',$NomRapport);
				$ParamTitre = "style=font-size:".$param_canevas['title']['style']['font-size'].";color:".$param_canevas['title']['style']['color']."";				
					
				$header = str_replace("TITLE",$Titre, file_get_contents("".$path.$path_header_footer."header.html"));
				$header = str_replace("STYLE",$ParamTitre, $header);
				$header = str_replace("DATE",$DateHeader , $header);
				$header = str_replace("NOM_CLIENT",$NomClient, $header);
				$header = str_replace("DESCRIPTION",$DescriptionHeader,$header);
					
				$nameImg = explode("min_", $param_canevas['imageHeader']);
				$header = str_replace("IMAGEHEADER",$nameImg[1], $header);
				
				$output = $header.$output.$footer;
				
				if($Viewer!='true')
				{
					$open = fopen($filenameHtml,"w+");
					fwrite($open, $output);
					fclose($open);
			
					$patterns[0] = '/{literal}/';
					$patterns[1] = '/{\/literal}/';
					$replacements[0] = '';
					$replacements[1] = '';
					$HtmlToPdf=preg_replace($patterns, $replacements, $output);					
				
					$filenameHtmlToPdf = "/data/report/canevas/".$tmpNameCanevas."/".$tmpNomRapport."_".$date."ToPdf".".html";
					$open = fopen($path.$filenameHtmlToPdf,"w+");
					fwrite($open,$HtmlToPdf);
					fclose($open);
				
					$command = "xvfb-run wkhtmltopdf --margin-left 0 --margin-right 0 --margin-top 5 --margin-bottom 5 --page-size A4 -l 127.0.0.1".$filenameHtmlToPdf." ".$path.$filenamePdf; 
					exec($command,$out,$ret);
				
					$DeleteHtmlToPdf=unlink($path.$filenameHtmlToPdf);
				}
				else
				{
					$patterns[0] = '/{literal}/';
					$patterns[1] = '/{\/literal}/';
					$replacements[0] = '';
					$replacements[1] = '';
					$output=preg_replace($patterns, $replacements, $output);
					echo $output;
				}
			}
			if($Viewer!='true')
			{
				$query=Model_Report::addReport($dbconnection,$NomRapport,$today,$filenameHtml,$filenamePdf,$Canevas_Id,$Start,$End);
				echo $query;
			}
		}
		else
		{
			echo "<td> Error Include Block not exist </td>";
		}		
	}
	catch(EsiaDbException $e)
	{
		echo "<td> Generation KO EsiaDbException => ".$e->getMessage()." </td>";
	}
	catch(Exception $e)
	{
		echo "<td> Generation KO Exception => ".$e->getMessage()."  </td>";
	}
}
else
{
	echo "<td> Error Canevas not exist </td>";
}

/**
 @brief retourne la valeur associé à la clé
 @detail retourne la valeur associé au paramètre. ou une valeur par défaut
 @params array $options le tableau de paramètre global
 @params string $name1 le nom court du paramètre (ex: -H 127.0.0.1)
 @params string $name2 le nom long du paramètre (ex: --host 127.0.0.1)
 @params string $default (optionnel) la valeur par défaut du paramètre s'il n'est pas spécifié
 @retval	null|mixed la valeur du paramètre
 @throw void
 */
function getParam($options,$name1,$name2,$default=null)
{
	if( isset( $options[$name1] ) ) return $options[$name1];
	if( isset( $options[$name2] ) ) return $options[$name2];
	return $default;
}

/**
 @brief retourne le string sans les accents
 @detail enleve les accents qui se trouve dans le string
 @params string $str le string à modifier
 @params string $charset (optionnel)
 @retval	le string
 */
function remove_accents($str, $charset='utf-8')
{
	$str = htmlentities($str, ENT_NOQUOTES, $charset);

	$str = preg_replace('#&([A-za-z])(?:acute|cedil|caron|circ|grave|orn|ring|slash|th|tilde|uml);#', '\1', $str);
	$str = preg_replace('#&([A-za-z]{2})(?:lig);#', '\1', $str); // pour les ligatures e.g. '&oelig;'
	$str = preg_replace('#&[^;]+;#', '', $str); // supprime les autres caractères

	return $str;
}
?>
