#!/usr/bin/php
<?php
/**
 * @name report_generate_cron
 * @description fichier qui s'execute grace à la tache cron
 *		Genere les rapports du jour et les envoie aux personnes interessées
 * @author Victor Marin <v.marin@esia-sa.com>
 * @date Mars 2017
 */

$_SERVER['DOCUMENT_ROOT']='/usr/local/esia/public_html/';
$path = rtrim ($_SERVER['DOCUMENT_ROOT'],'/');
include $path.'/esia.conf.php';
include_once MVCMODEL;
include_once $path.'/Model_adm.php';
include_once 'Model_Report.php';

try
{
	$dbconnection = new PDO('pgsql:host='.DB_HOST.';port='.DB_PORT.';dbname='.DB_NAME, DB_USERNAME, DB_PWD);
	$dbconnection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_WARNING);
}
catch(Exception $e)
{
	echo 'PDO SQL ERROR: '.$e->getMessage().'<br />';
	echo 'N° : '.$e->getCode();
}

// Info Mail
$serveur     = Model_esia::getConfiguration($dbconnection,"REPORT_MAIL_SMTP");
$utilisateur = Model_esia::getConfiguration($dbconnection,"REPORT_MAIL_USER");
$passwordMail= Model_esia::getConfiguration($dbconnection,"REPORT_MAIL_PASSWORD");
$sll_mail    = Model_esia::getConfiguration($dbconnection,"REPORT_MAIL_SSL");
$port 		 = Model_esia::getConfiguration($dbconnection,"REPORT_MAIL_SMTP_PORT");
$expiditor   = Model_esia::getConfiguration($dbconnection,"REPORT_MAIL_FROM");

$query=Model_Report::getReportCanevas($dbconnection);
$ListUser = Model_adm::searchUser($dbconnection);
$arr = Model_esia::getWebPlugin($dbconnection,false,'WEBP_REPORT');
$path_report = $path.$arr[0]['apache_path'];

foreach ($query as $Canevas)
{
	if(!empty($Canevas)&& $Canevas!=null)
	{
		$End = $Canevas['canevas_date_nextgeneration'];
		$param_canevas = json_decode($Canevas['canevas_parameter'],true);
	
		$End = date_format(new DateTime($End),'Y-m-d');
	 	$today = date("Y-m-d");
		 	 
	 	if($End==$today) // Verifie la date du jour
	 	{	
	 		if(isset($param_canevas['lang']))
	 		{
	 			shell_exec("php ".$path_report."report_generate.php -a generate -i ".$Canevas['canevas_id']." -n '".$param_canevas['title']['text']."' -l '".$param_canevas['lang']."'");
	 		}
	 		else
	 		{
	 			shell_exec("php ".$path_report."report_generate.php -a generate -i ".$Canevas['canevas_id']." -n '".$param_canevas['title']['text']."' -l 'fr'");
	 		}
				 		 		
	 		// Recup le(s) Rapport(s) à la date du jour	
			$ListReport = Model_Report::getReport_of_ReportCanevas($dbconnection,$Canevas['canevas_id'],$today);
	 		foreach ($ListUser as $u)
	 		{		 		
		 		if (in_array($u['id'], $param_canevas['ListUser']))
		 		{						 				 			
		 			$sujet = $param_canevas['SubjetMail'];
		 			$data = $param_canevas['TextMail'];
		 			
					$sujet= preg_replace('#\'#','\'\\\'\'',$sujet);			
					$data = preg_replace('#\\n#','<br>',$data);
					$data = preg_replace('#\'#','\'\\\'\'',$data);
					
					$exec = $path_report."send_mail.pl";
					$exec .=" -H '".cleanArgs($serveur['REPORT_MAIL_SMTP']['value'])."'";
					$exec .=" -p '".cleanArgs($port['REPORT_MAIL_SMTP_PORT']['value'])."'";
					$exec .=" -S '".cleanArgs($sll_mail['REPORT_MAIL_SSL']['value'])."'";
					
					$exec .=" -e '".cleanArgs($expiditor['REPORT_MAIL_FROM']['value'])."'";
					$exec .=" -U '".cleanArgs($utilisateur['REPORT_MAIL_USER']['value'])."'";
					$exec .=" -P '".cleanArgs($passwordMail['REPORT_MAIL_PASSWORD']['value'])."'";
					$exec .=" -T '".cleanArgs($u['mail'])."'";
					$exec .=" -s '".$sujet."' -d '".$data;
					
		 			foreach ($ListReport as $report)
		 			{
		 				$path_pdf=$report['path_pdf'];
		 				preg_match("/.*\/(.*)/",$path_pdf,$filepdf); 		
						exec($exec." -f ".$filepdf[1]." -F ".$path.$report['path_pdf']);
		 			}
		 		}
		 	}
		 	$date = date_create($today);		 	
		 	if($Canevas['canevas_interval']=="1 mon")
		 	{
		 		date_add($date, date_interval_create_from_date_string('1 month'));
		 	}
		 	else
		 	{
		 		date_add($date, date_interval_create_from_date_string($Canevas['canevas_interval']));
		 	}		 	
		 	$query=Model_Report::UpdtReportCanevas($dbconnection,$Canevas['canevas_id'],$Canevas['canevas_name'],$Canevas['canevas_description'],$Canevas['canevas_interval'],date_format($date, 'd/m/Y'),$Canevas['canevas_parameter']);
		}
	}
}
function cleanArgs($val)
{
	$val = trim($val);
	$val = escapeshellcmd($val);
	return $val;
}
?>