CREATE TABLE report_block_group
(
  report_block_group_id serial NOT NULL,
  report_block_group_name character varying(30),
  CONSTRAINT report_block_group_primary_key PRIMARY KEY (report_block_group_id)
)
WITH (
  OIDS=FALSE
);
ALTER TABLE report_block_group
  OWNER TO esia;

ALTER TABLE report_block
   ADD COLUMN block_group_id integer;


INSERT INTO report_block_group VALUES (default,'AVAILABILITY');
INSERT INTO report_block_group VALUES (default,'INCIDENT');
INSERT INTO report_block_group VALUES (default,'VALUE');
INSERT INTO report_block_group VALUES (default,'USERESOURCE');

UPDATE report_block SET block_group_id = (SELECT report_block_group_id FROM report_block_group WHERE report_block_group_name='AVAILABILITY')
WHERE block_name IN ('REPORT_SERVICE_AVAILABILITY','REPORT_NODE_AVAILABILITY','REPORT_AVAILABILITY_GROUP_NODE');

UPDATE report_block SET block_group_id = (SELECT report_block_group_id FROM report_block_group WHERE report_block_group_name='INCIDENT')
WHERE block_name IN ('REPORT_NODE_INCIDENT','REPORT_INCIDENT_GROUP_NODE','REPORT_SERVICE_INCIDENT','HARDWARE_INCIDENT');

UPDATE report_block SET block_group_id = (SELECT report_block_group_id FROM report_block_group WHERE report_block_group_name='VALUE')
WHERE block_name IN ('REPORT_VALUE_SERVICE_NODE','REPORT_VALUE_SERVICE_SERVICE','REPORT_VALUE_SERVICE_GROUP_NODE','REPORT_VALUE_PLUGIN_GROUP_NODE');

UPDATE report_block SET block_group_id = (SELECT report_block_group_id FROM report_block_group WHERE report_block_group_name='USERESOURCE')
WHERE block_name IN ('REPORT_USERESOURCE_GROUP_NODE','REPORT_USERESOURCE_NODE');
